package com.qfleng.demo


class Data constructor(val key:String,var value:String) {
    var pre : Data? = null
    var next : Data? = null
}


class LRUCache constructor(val max: Int = 4) {
    private var head: Data? = null
    private var end: Data? = null

    private val map = HashMap<String, Data>()


    fun get(key: String): String? {
        val data = map[key] ?: return null
        moveToLast(data)
        return data.value
    }


    fun put(data: Data) {
        if (map.contains(data.key)) { //存在
            val old = map[data.key]
            old!!.value = data.value
            moveToLast(old)
        } else { //不存在
            if (map.size >= max) {
                remove(head!!)
                map.remove(head!!.key)
            }
            add(data)
            map[data.key] = data
        }
    }

    fun delete(key: String) {
        val data = map[key]
        if (null != data) {
            remove(data)
            map.remove(key)
        }
    }


    private fun moveToLast(data: Data) {
        if (end == data) {
            return
        }

        remove(data)
        add(data)
    }

    private fun remove(data: Data) {
        when (data) {
            end -> {
                end = end!!.pre
            }
            head -> {
                head = head!!.next
            }
            else -> { //中间情况，如文中所说的获取数据2的情况
                data.pre!!.next = data.next
                data.next!!.pre = data.pre
            }
        }
    }

    private fun add(data: Data) {
        if (null == head) head = data

        if (null != end) {
            end!!.next = data
            data.pre = end
            data.next = null
        }
        end = data

    }

    fun print(){
        var data:Data? =  head
        while(null != data){
            println(data.value)

            data = data.next
        }
    }
}

fun main(args: Array<String>) {
   
    val cache = LRUCache()
    cache.put(Data("1","数据1"))
    cache.put(Data("2","数据2"))
    cache.put(Data("3","数据3"))
    cache.put(Data("4","数据4"))
    
    cache.print()

    println("\n获取数据2之后")
    cache.get("2")
    cache.print()

    println("\n添加数据5之后")
    cache.put(Data("5","数据5"))
    cache.print()

}